
021/043 11 Jun 90 19:26:42
From:   John Emmert
To:     Ken Manton
Subj:   Re: Advanced MS DOS
Attr:   
------------------------------------------------
;------------------------------------------------------------
; I took this directly from Ray Duncan's Advanced MS-DOS,
; page 154. It works for me. Did you just enter the code
; verbatime, or did you give it the necessary extras to make
; it a .com or .exe file? This code should compile, link, and
; exe2bin to a working .com file. It did for me, just like
; the book said it would. The code sample in the book will
; not work unless you add the necessary overhead to make it a
; .com or .exe file. Try out this message with your assembler.
;------------------------------------------------------------


code   segment

       assume  cs:code, ds:code, ss:code, es:code

       org     100h

main   proc    near

start:
       mov     dx,offset mybuff   ; set DTA to working
       mov     ah,1ah             ; buffer for DOS
       int     21h
       mov     dx,offset myfcb    ; Search for First
       mov     ah,11h
       int     21h
       or      al,al              ; any matches at all?
       jnz     exit               ; no, quit.

display:
       mov     dx,offset crlf     ; send carriage return/
       mov     cx,2               ; linefeed sequence
       mov     bx,1               ; to standard output.
       mov     ah,40h
       int     21h
       mov     dx,offset mybuff+1 ; display name of
       mov     cx,11              ; matching file
       mov     bx,1               ; on standard output.
       mov     ah,40h
       int     21h

nextfile:
       mov     dx,offset myfcb    ; Search for Next.
       mov     ah,12h
       int     21h
       or      al,al              ; any more matches?
       jz      display            ; yes, display filename.

exit:
       mov     ax,4C00h           ; return to DOS.
       int     21h

main   ENDP


;------------------------------------------------------------
;                        DATA AREA
;------------------------------------------------------------

crlf   db      0dh,0ah            ; carriage return/
                                  ; linefeed string

myfcb  db      0                  ; drive = "current"
       db      8 dup ('?')        ; filename = wildcard
       db      'ASM'              ; extension = "ASM"
       db      25 dup (0)         ; remainder of FCB = zero

mybuff db      64 dup (0)         ; working buffer for DOS


code   ends                       ; end code segment
       end     start


--- Opus-CBCS 1.12
 * Origin: Gateway - Huntsville, Al. - (205) 880-7723 (1:373/2.0)
